#!/usr/bin/perl

require "config.pl";

if ($ENV{'REQUEST_METHOD'} eq "GET") {
 $mybuffer=$ENV{'QUERY_STRING'};
} 
elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
 read(STDIN, $mybuffer, $ENV{'CONTENT_LENGTH'});
}

@pairs = split(/&/, $mybuffer);
foreach $pair (@pairs) {
 ($name, $value) = split(/=/, $pair);
 $value =~ tr/+/ /;
 $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $value =~ s/<([^>]|\n)*>//g;
 $value =~ s/<!--(.|\n)*-->//g;
 $value =~ s/^\s+//;
 $value =~ s/\s+$//;
 $value=&detag($value);
 $value=&despace($value);
 $FORM{$name} = $value;
}


print "Content-type: text/html\n\n";

&html_start;

$action = $FORM{'action'};

open(DATA, "$basename");
@data = <DATA>;
close(DATA);

$lines = $#data + 1; 

$number = $FORM{'number'};
if ($number eq "") { $number=1; }
if (&lays_in (1, $number, $lines)==0) {
 #&eror ("     ($number)!  : 1-$lines");
 $number=1;
}

&menu;
#print "$lines $number";

if ((!@data) && ("$action" ne 'add')) { 
 print "<center><h3>  </h3></center>";
 &html_end;
 exit;
}

if ($action eq 'edit') { &edit; }
elsif ($action eq 'delete') { &delete; }
elsif ($action eq 'add') { &add; }
else { &form ($number); }

&html_end;
exit;

sub error ($msg) {
 print "<center><b>$msg</b></center>";
 &html_end;
 exit;
}

sub form {
 my $number=@_[0];
 chomp($data [$number-1]);
 ($fio1, $dis1, $spec1, $sovet1, $addr1, $aref1, $date1) = split(/\t/, $data [$number-1]);
 &tab_start;
 print "<form method=\"post\"><input type=hidden name=action value=edit><input type=hidden name=number value=\"$number\">\n";
 print "<input type=hidden name=aref value=\"$aref1\">\n";
 print "   <input type=text name=fio size=60 maxlength=255 value=\"$fio1\">\n";
 print "<br>  <input type=text name=dis size=60 maxlength=255 value=\"$dis1\">\n";
 print "<br> <input type=text name=spec size=60 maxlength=255 value=\"$spec1\">\n";
 print "<br>  <input type=text name=sovet size=60 maxlength=255 value=\"$sovet1\">\n";
 print "<br>  <input type=text name=addr size=60 maxlength=255 value=\"$addr1\">\n";
 print "<br>  <input type=text name=date size=60 maxlength=255 value=\"$date1\">\n";
 print "<br><input type=submit class=button name=ok value=\"\">\n";
 print "<input type=button class=button name=\"current\" value=\": $number\">\n";
 print "<input type=button class=button name=\"all\" value=\": $lines\"></form>\n";

 print "<form enctype=\"multipart/form-data\" method=\"post\" action=\"load.pl\">\n";
 print "<br><small><b>!</b>    ,    <br> ,               </small>\n";
 print "<br>   <input type=file name=uploadfile><input type=hidden name=number value=$number>\n";
 print "<br> : $aref1";
 print "<br><input type=submit class=button value=\"\"></form>\n";
 &tab_end;
}

sub menu {
 $n1 = $number +1;
 if ($n1>$lines) { $n1=$lines; }
 $n2 = $number -1;
 if ($n2<1) { $n2=1; }
 print "<center><p>&nbsp;</p>";
 print "[<a href=\"$admin?number=1\"></a>]";
 print " [<a href=\"$admin?number=$n1\"></a>]";
 print " [<a href=\"$admin?action=add\"></a>]";
 print " [<a href=\"$admin?action=delete&number=$number\"></a>]";
 print " [<a href=\"$admin?number=$n2\"></a>]";
 print " [<a href=\"$admin?number=$lines\"></a>]";
 print " [<a href=\"$cginame\"></a>]";
 print "</center>";
}

sub addstring { 
 my $dt = &getstrdate;
 $lines = $#data + 1;
#print "addstring: $lines";
 my $s = "\t\t\t\t\t\t$dt";
 if ($lines>0) { $s="$s\n"; }
 open (DATA, ">$basename");
 flock(DATA,2);
 print DATA "$s";
 if ($lines>0) { print DATA @data; }
 flock(DATA,8);
 close (DATA);
}

sub add {
 &addstring;
 open(DATA, "$basename");
 @data = <DATA>;
 close(DATA);
 $number = 1;
 $lines = $#data + 1;
 &form ($number);
}

sub delete {
 $number=$FORM{'number'};

 chomp $data[$number-1];
 my ($fio0, $dis0, $spec0, $sovet0, $addr0, $aref0, $date0) = split(/\t/, $data [$number-1]);
 if ($aref0 ne "") {
  unlink ("$basedir/$aref0");
 }

 open(DATA, "$basename");
 @data = <DATA>;
 close(DATA);
 splice (@data, $number-1, 1);
 open (DATA, ">$basename");
 flock(DATA,2);
 print DATA @data;
 flock(DATA,8);
 close (DATA);
 $number--;
 if ($number<1) { $number=1; }
 $lines--;
 if ($lines>0) {
  &form ($number);
 }
 else {
  print "<center><h3>  </h3></center>";
 }
}

sub edit {
 my $number=$FORM{'number'}; 
 my $fio=$FORM{'fio'};
 my $dis=$FORM{'dis'};
 my $spec=$FORM{'spec'};
 my $sovet=$FORM{'sovet'};
 my $addr=$FORM{'addr'};
 my $date=$FORM{'date'};
 my $aref=$FORM{'aref'};

 open(DATA, "$basename");
 @data = <DATA>;
 close(DATA);
 chomp $data[$number-1];
 $data[$number-1]="$fio\t$dis\t$spec\t$sovet\t$addr\t$aref\t$date";
#print "edit: $number $lines";
 if ($number < $lines) { $data[$number-1]="$data[$number-1]\n"; }
 open (DATA, ">$basename");
 flock(DATA,2);
 print DATA @data;
 flock(DATA,8);
 close (DATA);
 $lines = $#data + 1;
 &form ($number);
}
